var log4js = require('log4js');

function logger() {
	this.configure = doConfigure;
}

function doConfigure(config) {
	var path;
	if (config.deviceType) {
		switch (config.deviceType.toLowerCase()) {
			case "edge300":
			case "edge340":
				path = "/apps/nexus2/Logs/";
				break;
			case "dmp4310":
			case "dmp4400":
				path = "/tmp/ftproot/usb_1/Logs/";
				break;
		}
	}
	var appenders = [];
	appenders.push({ type: 'console' });
	if (path) {
		appenders.push({
			type: 'file',
			absolute : true,
			filename: path + 'nodewatchdoglog.txt',
			category: 'watchdog',
			maxLogSize : 20480,
			backups : 3
		});
	}

	log4js.configure({
		appenders: appenders
	});
}

exports.Logger = logger;