var exec = require('child_process').exec;
var log4js = require('log4js');
var logger;
var warnCount;
var ignore;

function XOrgWatchdog(config) {
	//public interfaces
	this.execute = doExecute;

	//private init
	logger = log4js.getLogger('watchdog');
	logger.setLevel('WARN');
	warnCount = 0;
	ignore = false;
}

function doExecute() {

	if (ignore == true)
		return;

	exec("top -n 1 -b | grep Xorg | sed -n 1p | grep -v grep | awk '{print $9,$11,$12}'", function (error, stdout, stderr) {
		//exec("ps aux | grep vmware | grep -v grep | awk '{print $3,$10,$11 }' | sed -n 1p",function(error,stdout,stderr){
		var str = stdout.toString();
		str = str.split('\r').join('').split('\n').join('');
		var arr = str.split(' ');
		if (arr.length == 3) {
			var cpu = parseFloat(arr[0]);
			var time = arr[1];
			var processName = arr[2];
			if (cpu >= 79) {
				warnCount++;
				if (warnCount >= 24) {
					logger.warn('Xorg cpu usage is more than 79% for more than 24 times (2 minutes)');
					logger.warn('Possible Xorg hung. Extra information:');
					logger.warn('current cpu% : ' + cpu);
					logger.warn('current cpu time : ' + time);
					warnCount = 0;
					ignore = true;
					rebootDevice();
				}
			}else{
				if (warnCount > 0){
					logger.warn('Resetting warn count to 0 as Xorg cpu usage goes below 79%. Extra info:');
					logger.warn('warn count:' + warnCount);
					logger.warn('current cpu% : ' + cpu);
					logger.warn('current cpu time : ' + time);
				}
				warnCount = 0;
			}
		}
	});
}

function rebootDevice(){
	logger.warn('Flagging download manager to reboot the device');
	exec('touch /apps/nexus2/install-reboot', function (error, stdout, stderr) {
	});
};

module.exports = XOrgWatchdog;