/**
 * New node file
 */
var ChromeCrash = require('../../services/watchdog/chromecrash');
var fs = require('fs');
var path = require('path');

describe('Testing Watchdog behaviours', function() {

	it('ensure chrome is restarted when core dump exists', function(done) {

		var filepath = './tests/behaviour/';
		var filename = 'chrome_random-random.core';
		var sourcePath = path.join(filepath, 'target');
		var backupPath = path.join(filepath, 'backup');
		var sourcefile = path.join(sourcePath, filename);
		var backupFile = path.join(backupPath, 'chrome-crash.core');
		fs.unlink(backupFile, function(err) {
			fs.mkdir(path.dirname(sourcefile), function(err) {
				fs.writeFile(sourcefile, '', function(err) {
					var c = new ChromeCrash();
					c.execute(sourcefile, backupFile, function(event) {
						expect(event).toEqual('chromerestarted');
						done();
					});

				});
			});
		});
	});

	it('ensure chrome is not restarted when core dump doesn\'t exists', function(done) {

		var filepath = './tests/behaviour/';
		var filename = 'chrome_random-random-not.core';
		var sourcePath = path.join(filepath, 'target');
		var backupPath = path.join(filepath, 'backup');
		var sourcefile = path.join(sourcePath, filename);
		var backupFile = path.join(backupPath, 'chrome-crash-not.core');
		fs.unlink(backupFile, function(err) {
			fs.unlink(sourcefile, function(err) {
				var c = new ChromeCrash();
				c.execute(sourcefile, backupFile, function(event) {
					expect(event).toEqual('chromenotrestarted');
					done();
				});
			});
		});

	});
})