/**
 * New node file
 */
var ChromeCrash = require('../../services/watchdog/chromecrash');
var fs = require('fs');
var path = require('path');

describe('Testing Watchdog integrations', function() {

	it('ensure chromecrash check the file exists', function(done) {
		var file = './tests/integration/chrome_random-random.core';
		var chromeCrash = new ChromeCrash();
		var oncheck = function(files) {
			expect(files.length >= 0).toBe(true);
			fs.unlink(file);
			done();
		};
		fs.writeFile(file, '', null, function(err) {
			chromeCrash.isFileNameExists('./tests/integration/chrome*.core', oncheck);
		});

	});

	it('ensure chromecrash check the file doesn\'t exists', function(done) {
		var chromeCrash = new ChromeCrash();
		var oncheck = function(files) {
			expect(files.length == 0).toBe(true);
			done();
		};
		chromeCrash.isFileNameExists('./tests/integration/chrome*.core2', oncheck);
	});

	it('ensure chromecrash backup the file', function(done) {
		var chromeCrash = new ChromeCrash();
		var file = './tests/integration/target/chrome-random.core';
		var targetbackup = './tests/integration/backup/chrome-crash.core';
		fs.mkdir(path.dirname(file), function(err) {
			fs.writeFile(file, '', null, function(err) {
				chromeCrash.copyFile(file, targetbackup, function(success) {
					expect(success).toBe(true);
					if (success === true) {
						fs.readFile(targetbackup, function(err, data) {
							var exists = false;
							if (err === null || err === undefined) {
								exists = true;
							}
							expect(exists).toBe(true);
							fs.unlink(file,function(err){
								done();
							});
							
						});
					} else {
						fs.unlink(file,function(err){
							done();
						});
					}
				});
			});
		});
	});

	it('ensure chromecrash delete the file', function(done) {
		var chromeCrash = new ChromeCrash();
		var file = './tests/integration/test-delete.file';
		fs.writeFile(file, '', null, function(err) {
			chromeCrash.deleteFile(file, function(success) {
				expect(success).toBe(true);
				if (success === true) {
					fs.readFile(file, function(err, data) {
						var exists = false;
						if (err === null || err === undefined) {
							exists = true;
						}
						expect(exists).toBe(false);
						done();
					})
				} else {
					done();
				}
			});
		});
	});
});