#!/bin/sh
_tempPath="/tmp/appspace"
logfile=$_tempPath/appspace-reso.log
lastres=""
lastrot=""
while true
do
	sleep 15
	
	if [ -f /apps/nexus2/config/enablecheckres ] ; then
		:
	else
		echo "Check resolution is disabled"
		continue
	fi
	
	screeninfo="$(curl -s -X GET -k https://127.0.0.1/api/v3/screen)"
	
	if [ "$screeninfo" = "" ] ; then
		continue
	fi
	
	screenres=$(/apps/nexus2/node -pe 'JSON.parse(process.argv[1]).DVI1.current_resolution' "$screeninfo")
	screenrot=$(/apps/nexus2/node -pe 'JSON.parse(process.argv[1]).DVI1.current_rotation' "$screeninfo")
	screenresVGA=$(/apps/nexus2/node -pe 'JSON.parse(process.argv[1]).VGA1.current_resolution' "$screeninfo")
	screenrotVGA=$(/apps/nexus2/node -pe 'JSON.parse(process.argv[1]).VGA1.current_rotation' "$screeninfo")
	
	echo "DVI res: $screenres"
	echo "DVI rot: $screenrot"
	echo "VGA res: $screenresVGA"
	echo "VGA rot: $screenrotVGA"
	
	if [ "$screenres" = "" ] || [ "$screenrot" = "" ] || [ "$screenres" = "undefined" ] || [ "$screenrot" = "undefined" ] ; then
		if [ "$screenresVGA" = "" ] || [ "$screenrotVGA" = "" ] || [ "$screenresVGA" = "undefined" ] || [ "$screenrotVGA" = "undefined" ] ; then
			lastres="undefined"
			lastrot="undefined"
			continue
		else
			echo "Using VGA values"
			screenres="$screenresVGA"
			screenrot="$screenrotVGA"
		fi
	else
		echo "Using DVI values"
	fi
	
	echo "Last res: $lastres"
	echo "Last rot: $lastrot"
	
	if [ "$lastres" = "" ] || [ "$lastrot" = "" ] ; then
		lastres="$screenres"
		lastrot="$screenrot"
		continue
	fi
	
	if [ "$screenres" = "$lastres" ] && [ "$screenrot" = "$lastrot" ] ; then
		:
	else
		d=`date`
		echo "$d - Before : $lastres ($lastrot)" >> $logfile
		echo "$d - After  : $screenres ($screenrot)" >> $logfile
		sleep 5
		echo "$d - Killing chrome as resolution/rotation changes" >> $logfile
		touch /apps/nexus2/restart-chrome
		lastres="$screenres"
		lastrot="$screenrot"
	fi
done
